import { Component, Inject } from 'ng-metadata/core';
const templateUrl = require('./load-config.html');
const styleUrl = require('./load-config.css');

@Component({
    selector: 'load-config',
    templateUrl,
    styleUrls: [ styleUrl ],
})
export class LoadConfigComponent {
    private isReady: boolean = false;
    private uploadFunc: Function;
    private state: 'load' | 'validate' = 'load';

    private constructor(@Inject('ApiService') private apiService: any) {
    }

    private handleTarballSelected(files: File[], callback: Function) {
        this.isReady = true;
        callback(true)
    }

    private handleTarballCleared() {
        this.isReady = false;
    }

    private uploadTarball() {
        this.uploadFunc(success => {
            if (success) {
                this.state = 'validate';
            }
            else {
                this.apiService.errorDisplay('Could not upload configuration. Please reload the page and try again.\n' +
                    'If this problem persists, please contact support')();
            }
        });
    }

    /**
     * When files are validated, this is called by the child to give us
     * the callback function to upload
     * @param files: files to upload
     * @param uploadFiles: function to call to upload files
     */
    private filesValidated(files, uploadFiles) {
        this.uploadFunc = uploadFiles;
    }
}